Index: /packaging/qt4.spec
===================================================================
--- /packaging/qt4.spec	(revision 1079)
+++ /packaging/qt4.spec	(revision 1080)
@@ -96,6 +96,7 @@
 %files
 %defattr(-,root,root,-)
+%doc %{pkg_docdir}/
 %docdir %{pkg_docdir}/
-%doc %{pkg_docdir}/*
+%{pkg_docdir}/*
 %if "%{qt_prefix}" != "%{_prefix}"
 %dir %{qt_prefix}/
@@ -130,8 +131,11 @@
 
 %pre
-
 %warpin_conflicts_begin
 netlabs.org\Qt4\Runtime
 %warpin_conflicts_end
+
+%post
+# clean up the plugin/font cache to remove old entries (@todo other users?)
+rm -f "$HOME/.config/Trolltech.ini"
 
 #------------------------------------------------------------------------------
@@ -198,5 +202,7 @@
 
 Requires:   %{name}-pm = %{version}-%{release}
+Requires:   %{name}-designer = %{version}-%{release}
 Requires:   %{name}-webkit = %{version}-%{release}
+Requires:   %{name}-doc = %{version}-%{release}
 
 %description demos
@@ -222,4 +228,8 @@
 %wps_object_create_end
 
+# clean up the qtdemo doc cache, otherwise the demo descriptions may not show up
+# if the old cache contains links to non-existent doc files (@todo other users?)
+rm -f "$HOME/.local/share/data/Trolltech/Assistant/qtdemo_%{ver_major}.%{ver_minor}.%{ver_patch}.qhc"
+
 %postun demos
 %wps_object_delete_all -n %{name}-demos
@@ -275,5 +285,5 @@
 %post linguist
 %wps_object_create_begin -n %{name}-linguist
-%{wps_qt4_folder}
+%{pkg_wps_folder_create}
 %{pkg_wps_base}_LINGUIST:WPProgram|Linguist|%{pkg_wps_folder_id}|EXENAME=((%{qt_bindir}/linguist.exe))
 %wps_object_create_end
@@ -304,7 +314,12 @@
 %post assistant
 %wps_object_create_begin -n %{name}-assistant
-%{wps_qt4_folder}
+%{pkg_wps_folder_create}
 %{pkg_wps_base}_ASSISTANT:WPProgram|Assistant|%{pkg_wps_folder_id}|EXENAME=((%{qt_bindir}/assistant.exe))
 %wps_object_create_end
+
+# clean up the assistant cache & search index (@todo other users?)
+rm -f "$HOME/.local/share/data/Trolltech/Assistant/assistant.qch.%{ver_major}.%{ver_minor}"
+rm -f "$HOME/.local/share/data/Trolltech/Assistant/qthelpcollection_%{ver_major}.%{ver_minor}.%{ver_patch}.qhc"
+rm -rf "$HOME/.local/share/data/Trolltech/Assistant/.qthelpcollection_%{ver_major}.%{ver_minor}.%{ver_patch}"
 
 %postun assistant
@@ -335,5 +350,5 @@
 %post designer
 %wps_object_create_begin -n %{name}-designer
-%{wps_qt4_folder}
+%{pkg_wps_folder_create}
 %{pkg_wps_base}_DESIGNER:WPProgram|Designer|%{pkg_wps_folder_id}|EXENAME=((%{qt_bindir}/designer.exe))
 %wps_object_create_end
@@ -369,4 +384,14 @@
 %{qt_bindir}/xmlpatternsvalidator.exe
 
+%post devel-tools
+%wps_object_create_begin -n %{name}-devel-tools
+%{pkg_wps_folder_create}
+%{pkg_wps_base}_PIXELTOOL:WPProgram|Pixel Tool|%{pkg_wps_folder_id}|EXENAME=((%{qt_bindir}/pixeltool.exe))
+%{pkg_wps_base}_HELPCONVERTER:WPProgram|Help Converter|%{pkg_wps_folder_id}|EXENAME=((%{qt_bindir}/qhelpconverter.exe))
+%wps_object_create_end
+
+%postun devel-tools
+%wps_object_delete_all -n %{name}-devel-tools
+
 #------------------------------------------------------------------------------
 %package doc
@@ -387,4 +412,17 @@
 %defattr(-,root,root,-)
 %{qt_docdir}/qch/*.qch
+
+%post doc
+%wps_object_create_begin -n %{name}-doc
+%{pkg_wps_folder_create}
+%{pkg_wps_base}_README_FOLDER:WPFolder|Readme Files|%{pkg_wps_folder_id}
+%{pkg_wps_base}_README:WPShadow|README|<%{pkg_wps_base}_README_FOLDER>|SHADOWID=((%{pkg_docdir}/README))
+%{pkg_wps_base}_CHANGES:WPShadow|CHANGES|<%{pkg_wps_base}_README_FOLDER>|SHADOWID=((%{pkg_docdir}/changes-4.7.3))
+%{pkg_wps_base}_README_OS2:WPShadow|README.OS2|<%{pkg_wps_base}_README_FOLDER>|SHADOWID=((%{pkg_docdir}/README.OS2))
+%{pkg_wps_base}_CHANGES_OS2:WPShadow|CHANGES.OS2|<%{pkg_wps_base}_README_FOLDER>|SHADOWID=((%{pkg_docdir}/CHANGES.OS2))
+%wps_object_create_end
+
+%postun doc
+%wps_object_delete_all -n %{name}-doc
 
 #------------------------------------------------------------------------------
@@ -479,4 +517,6 @@
 Qt applications and the API documentation.
 
+%files devel-all
+
 #------------------------------------------------------------------------------
 %prep