Index: /packaging/INSTALL.OS2
===================================================================
--- /packaging/INSTALL.OS2	(revision 1082)
+++ /packaging/INSTALL.OS2	(revision 1083)
@@ -25,7 +25,7 @@
 
 If you want to only install the Qt runtime itself (for example, to use it with
-an application not available in RPM repositories), type the following:
+an application not available in RPM repositories), type e.g. the following:
 
-  yum install qt qt-pm
+  yum install libqt4 libqt4-gui
 
 To get more information about installing RPM, please visit
Index: /packaging/INSTALL.OS2.develop
===================================================================
--- /packaging/INSTALL.OS2.develop	(revision 1082)
+++ /packaging/INSTALL.OS2.develop	(revision 1083)
@@ -19,5 +19,5 @@
 environment:
 
-  yum install qt-develop
+  yum install qt4-devel-kit
   
 To get more information about installing RPM, please visit
Index: /packaging/qt4.spec
===================================================================
--- /packaging/qt4.spec	(revision 1082)
+++ /packaging/qt4.spec	(revision 1083)
@@ -85,8 +85,22 @@
 #------------------------------------------------------------------------------
 
-Summary:    Qt 4 runtime
+Summary:    Qt 4 (dummy package)
 Group:      System Environment/Libraries
 
 %description
+%{descr_brief}
+
+This package is not actually generated (due to the missing %files section).
+It is present only because RPM requires Summary: and %description sections for
+the main package to exist.
+
+#------------------------------------------------------------------------------
+%package -n lib%{name}
+#------------------------------------------------------------------------------
+
+Summary:    Qt 4 runtime libraries
+Group:      System Environment/Libraries
+
+%description -n lib%{name}
 %{descr_brief}
 
@@ -94,5 +108,5 @@
 core, network and XML modules.
 
-%files
+%files -n lib%{name}
 %defattr(-,root,root,-)
 %dir %{pkg_docdir}/
@@ -132,15 +146,15 @@
 %{qt_libdir}/QtXmlP%{ver_major}.dll
 
-%pre
+%pre -n lib%{name}
 %warpin_conflicts_begin
 netlabs.org\Qt4\Runtime
 %warpin_conflicts_end
 
-%post
+%post -n lib%{name}
 # clean up the plugin/font cache to remove old entries (@todo other users?)
 rm -f "$HOME/.config/Trolltech.ini"
 
 #------------------------------------------------------------------------------
-%package sql-mysql
+%package -n lib%{name}-sql-mysql
 #------------------------------------------------------------------------------
 
@@ -148,17 +162,17 @@
 Group:      System Environment/Libraries
 
-Requires:   %{name} = %{version}-%{release}
-
-%description sql-mysql
+Requires:   lib%{name} = %{version}-%{release}
+
+%description -n lib%{name}-sql-mysql
 %{descr_brief}
 
 This package contains the MySQL plugin for Qt 4.
 
-%files sql-mysql
+%files -n lib%{name}-sql-mysql
 %defattr(-,root,root,-)
 %{qt_plugindir}/sqldrivers/qmysql%{ver_major}.dll
 
 #------------------------------------------------------------------------------
-%package sql-psql
+%package -n lib%{name}-sql-psql
 #------------------------------------------------------------------------------
 
@@ -166,25 +180,25 @@
 Group:      System Environment/Libraries
 
-Requires:   %{name} = %{version}-%{release}
-
-%description sql-psql
+Requires:   lib%{name} = %{version}-%{release}
+
+%description -n lib%{name}-sql-psql
 %{descr_brief}
 
 This package contains the PostgreSQL plugin for Qt 4.
 
-%files sql-psql
+%files -n lib%{name}-sql-psql
 %defattr(-,root,root,-)
 %{qt_plugindir}/sqldrivers/qpsql%{ver_major}.dll
 
 #------------------------------------------------------------------------------
-%package pm
-#------------------------------------------------------------------------------
-
-Summary:    Qt 4 GUI runtime
+%package -n lib%{name}-gui
+#------------------------------------------------------------------------------
+
+Summary:    Qt 4 GUI runtime libraries
 Group:      System Environment/Libraries
 
-Requires:   %{name} = %{version}-%{release}
-
-%description pm
+Requires:   lib%{name} = %{version}-%{release}
+
+%description -n lib%{name}-gui
 %{descr_brief}
 
@@ -192,5 +206,5 @@
 applications.
 
-%files pm
+%files -n lib%{name}-gui
 %defattr(-,root,root,-)
 %dir %{qt_plugindir}/designer
@@ -213,13 +227,13 @@
 
 #------------------------------------------------------------------------------
-%package webkit
-#------------------------------------------------------------------------------
-
-Summary:    Qt 4 WebKit runtime
+%package -n lib%{name}-webkit
+#------------------------------------------------------------------------------
+
+Summary:    Qt 4 WebKit runtime libraries
 Group:      System Environment/Libraries
 
-Requires:   %{name}-pm = %{version}-%{release}
-
-%description webkit
+Requires:   lib%{name}-gui = %{version}-%{release}
+
+%description -n lib%{name}-webkit
 %{descr_brief}
 
@@ -227,5 +241,5 @@
 technology.
 
-%files webkit
+%files -n lib%{name}-webkit
 %defattr(-,root,root,-)
 %{qt_plugindir}/designer/qwebv.dll
@@ -234,4 +248,23 @@
 
 #------------------------------------------------------------------------------
+%package -n lib%{name}-designer
+#------------------------------------------------------------------------------
+
+Summary:    Qt 4 Designer runtime libraries
+Group:      System Environment/Libraries
+
+Requires:   lib%{name}-gui = %{version}-%{release}
+
+%description -n lib%{name}-designer
+%{descr_brief}
+
+This package contains runtime Qt libraries for Designer components.
+
+%files -n lib%{name}-designer
+%defattr(-,root,root,-)
+%{qt_libdir}/QtDsgC%{ver_major}.dll
+%{qt_libdir}/QtDsgn%{ver_major}.dll
+
+#------------------------------------------------------------------------------
 %package demos
 #------------------------------------------------------------------------------
@@ -239,7 +272,7 @@
 Group:      Documentation
 
-Requires:   %{name}-pm = %{version}-%{release}
-Requires:   %{name}-designer = %{version}-%{release}
-Requires:   %{name}-webkit = %{version}-%{release}
+Requires:   lib%{name}-gui = %{version}-%{release}
+Requires:   lib%{name}-designer = %{version}-%{release}
+Requires:   lib%{name}-webkit = %{version}-%{release}
 Requires:   %{name}-doc = %{version}-%{release}
 
@@ -279,5 +312,5 @@
 Group:      Development/Tools
 
-Requires:   %{name}-pm = %{version}-%{release}
+Requires:   lib%{name}-gui = %{version}-%{release}
 
 %description qmlviewer
@@ -305,5 +338,5 @@
 Group:      Development/Tools
 
-Requires:   %{name}-pm = %{version}-%{release}
+Requires:   lib%{name}-gui = %{version}-%{release}
 
 %description linguist
@@ -336,5 +369,5 @@
 Group:      Development/Tools
 
-Requires:   %{name}-pm = %{version}-%{release}
+Requires:   lib%{name}-gui = %{version}-%{release}
 
 %description assistant
@@ -370,5 +403,6 @@
 Group:      Development/Tools
 
-Requires:   %{name}-pm = %{version}-%{release}
+Requires:   lib%{name}-gui = %{version}-%{release}
+Requires:   lib%{name}-designer = %{version}-%{release}
 
 %description designer
@@ -382,6 +416,4 @@
 %{qt_translationdir}/designer_??.qm
 %{qt_translationdir}/designer_??_??.qm
-%{qt_libdir}/QtDsgC%{ver_major}.dll
-%{qt_libdir}/QtDsgn%{ver_major}.dll
 %{qt_bindir}/designer.exe
 
@@ -401,5 +433,5 @@
 Group:      Development/Tools
 
-Requires:   %{name}-pm = %{version}-%{release}
+Requires:   lib%{name}-gui = %{version}-%{release}
 
 %description devel-tools
@@ -465,12 +497,12 @@
 
 #------------------------------------------------------------------------------
-%package devel
+%package -n lib%{name}-devel
 #------------------------------------------------------------------------------
 Summary:    Qt 4 development files
 Group:      Development/Libraries
 
-Requires:   %{name}-pm = %{version}-%{release}
-
-%description devel
+Requires:   lib%{name}-gui = %{version}-%{release}
+
+%description -n lib%{name}-devel
 %{descr_brief}
 
@@ -478,5 +510,5 @@
 applications using the Qt toolkit.
 
-%files devel
+%files -n lib%{name}-devel
 %defattr(-,root,root,-)
 %if "%{qt_headerdir}" != "%{_includedir}"
@@ -507,13 +539,13 @@
 
 #------------------------------------------------------------------------------
-%package webkit-devel
+%package -n lib%{name}-webkit-devel
 #------------------------------------------------------------------------------
 Summary:    Qt 4 WebKit development files
 Group:      Development/Libraries
 
-Requires:   %{name}-webkit = %{version}-%{release}
-Requires:   %{name}-devel = %{version}-%{release}
-
-%description webkit-devel
+Requires:   lib%{name}-webkit = %{version}-%{release}
+Requires:   lib%{name}-devel = %{version}-%{release}
+
+%description -n lib%{name}-webkit-devel
 %{descr_brief}
 
@@ -521,5 +553,5 @@
 develop applications using the Qt WebKit technology.
 
-%files webkit-devel
+%files -n lib%{name}-webkit-devel
 %defattr(-,root,root,-)
 %{qt_headerdir}/Qt/QtWebKit
@@ -532,5 +564,5 @@
 
 #------------------------------------------------------------------------------
-%package devel-all
+%package devel-kit
 #------------------------------------------------------------------------------
 Summary:    Qt 4 development kit
@@ -544,8 +576,8 @@
 Requires:   %{name}-devel-tools = %{version}-%{release}
 Requires:   %{name}-doc = %{version}-%{release}
-Requires:   %{name}-devel = %{version}-%{release}
-Requires:   %{name}-webkit-devel = %{version}-%{release}
-
-%description devel-all
+Requires:   lib%{name}-devel = %{version}-%{release}
+Requires:   lib%{name}-webkit-devel = %{version}-%{release}
+
+%description devel-kit
 %{descr_brief}
 
@@ -555,5 +587,5 @@
 Qt applications and the API documentation.
 
-%files devel-all
+%files devel-kit
 
 #------------------------------------------------------------------------------