Index: /trunk/CHANGES.OS2
===================================================================
--- /trunk/CHANGES.OS2	(revision 1084)
+++ /trunk/CHANGES.OS2	(revision 1085)
@@ -4,4 +4,146 @@
 
 CHANGES
+
+
+4.7.3 (15-09-2011)
+
+  Improvements:
+
+  - general: Updated Qt codebase to version 4.7.3 (see the changes-4.7.3 file
+    for details). This version should be binary compatible with the previous
+    version of Qt for OS/2.
+
+  - general: Enable building the QtDeglarative and QtWebKit libraries by
+    default.
+
+  - corelib: QProcess: Implemented new I/O pipe notification mechanism that
+    fixes a number of issues such as hangs and truncated data during inter-
+    process communication using redirection of standard I/O channels.
+
+  - corelib: Make the native QFileSystemWatcher engine a singleton to reduce
+    the number of clients connecting to the server (part of XWP) that has a
+    limit on the number of connections.
+
+  - corelib: Make the native QFileSystemWatcher recognize file changes (i.e.
+    changes in file date/time/size) using a special poller thread. The original
+    OS/2 file notification mechanism (used by XWP) does not report such changes.
+
+  - corelib: QDir: Filter out "." and ".." from root directory listings to be
+    consistent across different IFSes and to match Windows behavior.
+
+  - gui: QSound: Use shared mode by default.
+
+  - gui: Include higher res pixmaps in icons returned by
+    QCommonStyle::standardIcon().
+
+  - gui: Make QFileSystemModel put "." and ".." entries first.
+
+  - gui: Take style icons for SP_FileIcon & SP_DirIcon from QFileIconProvider
+    by default.
+
+  - gui: Disable native window masking code as it is not complete (doesn't
+    work properly in DIVE mode).
+
+  - gui: Add support for short DLL names of QML plugins.
+
+  - gui: Enable linking to cups.dll at runtime (requires CUPS 1.4.8 and above).
+
+  - xsystray: Paint an empty box for NULL icons instead of leaving the old icon
+    if it was not NULL.
+
+  - xsystray: Fixed duplicate mouse click notifications.
+
+  - qmake: Make the shadow build mode work (both for Qt itself and for other
+    qmake-based applications).
+
+  - qmake: Do not shorten library names for DLLs when TARGET_SHORT is used.
+    This allows to use the same library name on all platforms.
+
+  - qmake: Added support for .SYM file generation on OS/2 (controlled by the
+    'sym' CONFIG option, which is present in release builds by default).
+
+  - qmake: Added replace functions 'fixpath_target' and 'fixpath_local'.
+
+  - qmake: Always add project directory to INCLUDEPATH. This makes individual
+    per-project 'INCLUDEPATH += .' statements unnecessary.
+
+  - qmake: Support FAST_BUILD make macro in generated Makefiles to disable slow
+    noncritical steps like .sym file generation.
+
+  - qmake: Recognize QMAKE_TARGET_VERSION in .pro which allows to embed the
+    version to EXE/DLL like VERSION but w/o appending the major version suffix
+    to the DLL name.
+
+  - qmake: Let INSTALL_ROOT override the dirve letter too to be able to redirect
+    make install to another drive.
+
+  - configure.cmd: Support build type options (-release, -debug,
+    -debug-and-release, -developer-build, -make and -nomake). Run with --help
+    or details.
+
+  - configure.cmd: Enable building examples by default.
+
+  Fixes:
+
+  - corelib: QProcess: Don't close the stdin pipe until the child reads it all.
+
+  - corelib: QProcess: Use dup()/dup2() instead of DosDupHandle() to make sure
+    the child process sees the correct state of stdin/out/err (e.g. isatty()).
+
+  - corelib: QProcess: Fixed the way how pipes are closed to makes sure that
+    feof() will return 1 and ferror() will not return 1 on the child end of the
+    pipe connected to its stdin. This fixes programs relying on these functions.
+
+  - corelib: QProcess: Fix possible hangs when using syncronous wait functions
+    in a GUI program.
+
+  - corelib: Fixed spontaneous failures to create native QFileSystemWatcher
+    objects.
+
+  - corelib: Don't eat drive letters in QDir::cleanPath() for paths like
+    "D:/../../mydir" (which would become "mydir").
+
+  - gui: Make sure that modal widgets never go behind the blocked widgets.
+
+  - gui: Make blocked widgets always follow the modal widget on Z-order change.
+    This makes sure that bringing the modal widget to front also raises all
+    widgets it blocks (keeping them right under it in the same Z-order).
+
+  - gui: Fixed the assertion in QPixmap::setMask() that could also lead to
+    creating pixmaps w/o masks.
+
+  - gui: Fixed creating HPOINTERs from QPixmaps with no mask. This fixes
+    setting PNG files with no mask as top-level window icnos.
+
+  - gui: Do not attempt to natively hide widgets with no handle and fix
+    hiding reparented child widgets with native handles.
+
+  - gui: Create native IDs (HWNDs) for all siblings and children of the widget
+    when its native ID is requested. This is for proper clipping and to be
+    compatible with other platforms.
+
+  - gui: Don't destroy widget's HWND on reparent until children are reparented,
+    otherwise all children with native HWNDs will be deleted.
+
+  - gui: Fix position errors on resize of child widgets during complex geometry
+    changes (e.g. manually changing the geometry of a layout-managed widget).
+
+  - gui: Fix Qt Assistant remote control which would only process
+    '\0'-terminated commands.
+
+  - gui: Fix signal recursion at Assistant startup in remote control mode that
+    could cause 100% CPU load.
+
+  - qmake: Fixed a hang when compiling .RC files with too long include paths.
+
+  - qmake: Don't call lxlite on phony targets.
+
+  - qmake: Make sure string quotes in DEFINES statements are processed
+    correctly (similar to other platforms).
+
+  - qmake: Several small fixes to path quoting and slashes that could cause
+    various build and install problems under certain conditions.
+
+  - uic: Fixed doubling EOLs (CRs) in pipe mode.
 
 
Index: /trunk/README.OS2
===================================================================
--- /trunk/README.OS2	(revision 1084)
+++ /trunk/README.OS2	(revision 1085)
@@ -1,3 +1,3 @@
-This is Qt version 4.6.3 for OS/2 and eCS.
+This is Qt version 4.7.3 for OS/2 and eCS.
 
 This document contains a brief information on the OS/2 version of the Qt
@@ -11,12 +11,4 @@
 To get a brief list of OS/2-specific changes from release to release
 please see the CHANGES.OS2 file included in this distribution.
-
-Please note that this version is binary incompatible with previous versions of
-Qt 4 for OS/2! This is not a behavior of the original Qt library (where versions
-with the same major number are usually binary compatible), but it is due to the
-fact that we continue to add missing features to the OS/2 version ot Qt and this
-cannot be done witout breaking the binary compatibility. On practice, this means
-that you need to recompile your applications with the new version of the Qt
-library in order to make them work with it.
 
 
@@ -241,8 +233,4 @@
 
 COMPILING QT
-
-You should skip this section if you installed the Qt development libraries using
-the WPI archive (that already contains compiled release versions of the
-libraries) and proceed directly to the next section.
 
 When the environment is set up as described above, you may build the Qt library.
@@ -348,5 +336,5 @@
 
      In order to nicely solve this problem, netlabs.org provides the official
-     binary builds of the Qt library distributed as WPI archives which are
+     binary builds of the Qt library distributed as RPM packages which are
      described in the next section.
 
@@ -355,57 +343,28 @@
 USING OFFICIAL BINARY QT ARCHIVES
 
-For your convenience, netlabs.org provides the following binary distributions
-of the Qt library (where X_Y_Z is the Qt version number) distributed as WPI
-archives:
-
-  qt-lib-X_Y_Z.wpi   - Runtime DLLs and binaries ("lib" archive)
-  qt-dev-X_Y_Z.wpi   - Development libraries, tools and headers ("dev" archive)
-
-These archives are called the official binary archives of the Qt library for
-OS/2. An official binary archive contains the most complete Qt build that
-enables all features of the Qt library and includes all standard Qt plugins
-implemented for the OS/2 platform at the time of the release.
-
-The "lib" archive contains the release versions of DLLs (and may contain a few
-helper binaries) necessary to run applications created using the Qt framework.
-This package is usually installed by end users together with Qt applications
-they want to use.
-
-The "dev" archive contains pre-built release versions of import libraries and
-a complete set of C++ include headers of the Qt framework. This package is used
-by developers and porters of Qt applications to build release versions of the
-applications that are binary compatibie with the Qt runtime provided by the
-official "lib" archive described above. Using the "dev" package requires the
-same environment as described in section "SETTING UP THE ENVIRONMET" above.
-
-Please note again that the "dev" archive is intended to make a final release
-build of the Qt application which you do when you decide to ship a new version
-to the end users -- makes sure that the deployed application will share the same
-Qt runtime with other Qt applications. However, for daily work it is highly
-recommended that you build the debug version of the Qt library yourself (using
-the full source code ZIP archive or directly from SVN) as described in section
-"COMPILING QT").
-
-Besides the "lib" and the "dev" archives, the following official archives exist
-that you may also find useful:
-
-  qt-examples-X_Y_Z.wpi  - Demo and example sources ("examples")
-
-The "examples" archive contains the source code and compiled binaries of the
-demo and example applications shipped with Qt. They serve as a good
-demonstration of the Qt library features and it is recommended to look at them.
-The binaries are compiled using the official "lib" archive. Please note that
-some demos and examples may miss from the arcvhice since not all features have
-been implemented in the OS/2 version of Qt yet.
-
-NOTE:
-
-     All .DLL and .EXE files of the official binary build contain a DESCRIPTION
-     string with the vendor field set to "netlabs.org" (by contrast, all custom
-     Qt builds will set the vendor field to what the USER environment variable
-     contains or to "anonymous" if USER is not set). Please note that you must
-     NOT set vendor to "netlabs.org" when creating your own builds of the Qt
-     library because it will make it difficult to identify various distributions
-     and track possible problems with the builds.
+For your convenience, netlabs.org provides all components of the Qt toolkit in
+the form of RPM packages. You may install latest versions of these packages
+from the netlabs.org RPM repositories using the YUM tool. For example, this
+command:
+
+     yum install qt4-devel-kit
+
+will install the complete Qt development environment, including headers,
+libraries, tools, examples and the Qt API documentaiton.
+
+This environment is also a proper way to build Qt applications you want to
+distribute because it guarantees that a proper version of the Qt runtime will
+be used by your applications when they are installed on the end user's machine.
+
+Buiding applications using this development environment is similar to using
+your own build of Qt but it is simpler in many ways because you don't need to
+set up paths to Qt tools and libraries and so on -- the RPM installation
+procedure will do this for you.
+
+If you don't have YUM or RPM installed, please visit the following page to
+learn how to do that:
+
+    http://svn.netlabs.org/rpm
+
 
 
@@ -665,5 +624,4 @@
      - multimedia module (QT_NO_MULTIMEDIA is defined).
      - OpenGL module (QT_NO_OPENGL is defined).
-     - declarative module (QT_NO_DECLARATIVE is defined).
      - tablet support (QT_NO_TABLET is defined).
 